class ParticleSystem {

  ArrayList particles; 
  boolean ps_up, ps_right, ps_down, ps_left;

  ParticleSystem() {
    particles = new ArrayList();
  }

  ParticleSystem(PVector origine, int nbr) {
    particles = new ArrayList();
    for (int i = 0; i < nbr; i++) {
      particles.add( new Particle(origine) );
    }
  } 

  ParticleSystem( PVector origine, PVector vel, int nbr) {
    particles = new ArrayList();
    for (int i = 0; i < nbr; i++) {
      particles.add( new Particle(origine, vel) );
    }
  }

  ParticleSystem( PVector origine, PVector vel, PVector acc, int nbr) {
    particles = new ArrayList();
    for (int i = 0; i < nbr; i++) {
      particles.add( new Particle(origine, vel, acc) );
    }
  } 


  void update() {
    for (int i = particles.size()-1; i >= 0; i--) {
      Particle p = (Particle) particles.get(i);
      border(p);
      p.render();
      if (p.life() ==false) particles.remove(i);
    }
  }

  boolean ParticleSystemIsEmpty() {
    if ( particles.size() <= 0 ) return true;
    else return false;
  }

  void addParticle(Particle p) {
    particles.add(p);
  }


  void setBorderBounce( boolean _up, boolean _right, boolean _down, boolean _left) {
    ps_up = _up;
    ps_right = _right;
    ps_down = _down;
    ps_left = _left;
  }

  void border(Particle p) {   
    if ( p.pos.x < 0 && ps_left ) p.vel.x*= p.bounce;
    if ( p.pos.x > width && ps_right ) p.vel.x*= p.bounce;
    if ( p.pos.y < 0 && ps_up ) p.vel.y*= p.bounce;
    if ( p.pos.y > height && ps_down ) p.vel.y*= p.bounce;
  }
}

